import React from 'react';
import { VideoBaseProps } from '../types';
export declare type MuxPlayerProps = VideoBaseProps & {
    playsInline?: boolean;
    playbackId: string;
    preventLoading?: boolean;
    fallbackGifOptions?: {
        /**
         * Maximum 640px (hard limit by Mux api)
         */
        width: number;
        /**
         * Maximum 640px (hard limit by Mux api)
         */
        height?: number;
        /**
         * Maximum 30fps (hard limit by Mux api)
         */
        fps: number;
    };
};
export declare const MuxPlayer: React.ForwardRefExoticComponent<({
    layout: "fill" | "fixed" | "responsive";
    placeholder?: React.ReactElement<any, string | ((props: any) => React.ReactElement<any, any> | null) | (new (props: any) => React.Component<any, any, any>)> | undefined;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
} & import("../types").LayoutFillProps & {
    onLoad?(): void;
} & import("../types").BackgroundVideoProps & {
    playsInline?: boolean | undefined;
    playbackId: string;
    preventLoading?: boolean | undefined;
    fallbackGifOptions?: {
        /**
         * Maximum 640px (hard limit by Mux api)
         */
        width: number;
        /**
         * Maximum 640px (hard limit by Mux api)
         */
        height?: number | undefined;
        /**
         * Maximum 30fps (hard limit by Mux api)
         */
        fps: number;
    } | undefined;
} & React.RefAttributes<unknown>) | ({
    layout: "fill" | "fixed" | "responsive";
    placeholder?: React.ReactElement<any, string | ((props: any) => React.ReactElement<any, any> | null) | (new (props: any) => React.Component<any, any, any>)> | undefined;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
} & import("../types").LayoutFillProps & {
    onLoad?(): void;
} & import("../types").VideoControlProps & {
    playsInline?: boolean | undefined;
    playbackId: string;
    preventLoading?: boolean | undefined;
    fallbackGifOptions?: {
        /**
         * Maximum 640px (hard limit by Mux api)
         */
        width: number;
        /**
         * Maximum 640px (hard limit by Mux api)
         */
        height?: number | undefined;
        /**
         * Maximum 30fps (hard limit by Mux api)
         */
        fps: number;
    } | undefined;
} & React.RefAttributes<unknown>) | ({
    layout: "fill" | "fixed" | "responsive";
    placeholder?: React.ReactElement<any, string | ((props: any) => React.ReactElement<any, any> | null) | (new (props: any) => React.Component<any, any, any>)> | undefined;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
} & import("../types").LayoutOtherProps & {
    onLoad?(): void;
} & import("../types").BackgroundVideoProps & {
    playsInline?: boolean | undefined;
    playbackId: string;
    preventLoading?: boolean | undefined;
    fallbackGifOptions?: {
        /**
         * Maximum 640px (hard limit by Mux api)
         */
        width: number;
        /**
         * Maximum 640px (hard limit by Mux api)
         */
        height?: number | undefined;
        /**
         * Maximum 30fps (hard limit by Mux api)
         */
        fps: number;
    } | undefined;
} & React.RefAttributes<unknown>) | ({
    layout: "fill" | "fixed" | "responsive";
    placeholder?: React.ReactElement<any, string | ((props: any) => React.ReactElement<any, any> | null) | (new (props: any) => React.Component<any, any, any>)> | undefined;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
} & import("../types").LayoutOtherProps & {
    onLoad?(): void;
} & import("../types").VideoControlProps & {
    playsInline?: boolean | undefined;
    playbackId: string;
    preventLoading?: boolean | undefined;
    fallbackGifOptions?: {
        /**
         * Maximum 640px (hard limit by Mux api)
         */
        width: number;
        /**
         * Maximum 640px (hard limit by Mux api)
         */
        height?: number | undefined;
        /**
         * Maximum 30fps (hard limit by Mux api)
         */
        fps: number;
    } | undefined;
} & React.RefAttributes<unknown>)>;
