import { VideoBaseProps, DistributiveOmit } from '../types';
export declare type VimeoProps = DistributiveOmit<VideoBaseProps, 'disableRemotePlayback'> & {
    playsInline?: never;
    videoId: string;
    layout: 'fixed' | 'responsive';
    onLoad?(): void;
    preventLoading?: boolean;
};
/**
 * Vimeo themselves start with an LQIP that then fades into the video.
 * This means that you probably want to use lqip placeholder as well, as using higher resolution image as placeholder,
 * would result a flicker to lqip again
 */
export declare const Vimeo: ({ style, className, layout, aspectWidth, aspectHeight, videoId, placeholder, onLoad, isBackgroundVideo, muted, autoPlay, loop, controls, preventLoading, }: VimeoProps) => JSX.Element;
