/// <reference types="react" />
interface IUseImageLoad {
    onLoad(): void;
}
/**
 *  Calls the provided 'onLoad' parameter if the image is loaded.
 *  Necessary in the rare event that the image source is loaded by the browser before javascript is initialized, meaning that the onLoad in the <img /> element won't fire
 */
export declare function useImageLoad({ onLoad }: IUseImageLoad): {
    imgRef: import("react").RefObject<HTMLImageElement>;
};
export {};
