'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var Hls = _interopDefault(require('hls.js'));

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

var PlaceHolderContext = /*#__PURE__*/React.createContext({
  isLoaded: false
});

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".video-module_containerBase__w-5z1 {\n  position: relative;\n}\n\n.video-module_video__3_QEl {\n  position: absolute;\n  width: 100%;\n  height: 100%;\n  object-fit: cover;\n  /* The video on purpose have higher z-index than placeholder (z-index: 1) */\n  z-index: 2;\n}\n\n.video-module_containerFill___Dqao {\n  width: 100%;\n  height: 100%;\n  object-fit: cover;\n}\n\n.video-module_containerResponsive__1uwhV {\n  width: 100%;\n}\n";
var videoStyles = {"containerBase":"video-module_containerBase__w-5z1","video":"video-module_video__3_QEl","containerFill":"video-module_containerFill___Dqao","containerResponsive":"video-module_containerResponsive__1uwhV"};
styleInject(css_248z);

var css_248z$1 = ".styles-module_containerBase__e-rVi {\n  position: relative;\n  overflow: hidden;\n}\n\n.styles-module_containerFill__2lii- {\n  width: 100%;\n  height: 100%;\n  object-fit: cover;\n}\n\n.styles-module_containerResponsive__2TVii {\n  width: 100%;\n}\n";
var styles = {"containerBase":"styles-module_containerBase__e-rVi","containerFill":"styles-module_containerFill__2lii-","containerResponsive":"styles-module_containerResponsive__2TVii"};
styleInject(css_248z$1);

function isVideoSource(object) {
  return 'src' in object;
}

var Video = /*#__PURE__*/React.forwardRef(function (_ref, forwardedRef) {
  var className = _ref.className,
      style = _ref.style,
      layout = _ref.layout,
      aspectWidth = _ref.aspectWidth,
      aspectHeight = _ref.aspectHeight,
      placeholder = _ref.placeholder,
      sources = _ref.sources,
      onLoad = _ref.onLoad,
      isBackgroundVideo = _ref.isBackgroundVideo,
      muted = _ref.muted,
      autoPlay = _ref.autoPlay,
      loop = _ref.loop,
      playsInline = _ref.playsInline,
      controls = _ref.controls,
      disableRemotePlayback = _ref.disableRemotePlayback;

  var _useState = React.useState(false),
      isVideoLoaded = _useState[0],
      setIsVideoLoaded = _useState[1];

  var videoRef = React.useRef(null);

  function onVideoLoad() {
    setIsVideoLoaded(true); // cache.add(src);

    if (onLoad) {
      onLoad();
    }
  }

  React.useEffect(function () {
    if (autoPlay || typeof autoPlay === 'undefined' && isBackgroundVideo) {
      var _videoRef$current;

      videoRef == null ? void 0 : (_videoRef$current = videoRef.current) == null ? void 0 : _videoRef$current.play();
    }
  }, [autoPlay, isBackgroundVideo]);
  var containerClassNameLayout = layout === 'fill' && styles.containerFill || layout === 'responsive' && styles.containerResponsive || '';
  var containerClassName = styles.containerBase + " " + containerClassNameLayout;
  var containerInlineStyles = layout === 'responsive' && {
    paddingBottom: aspectWidth / aspectHeight * 100 + "%"
  } || {};
  return React__default.createElement("div", {
    style: _extends({}, containerInlineStyles, style),
    className: containerClassName + " " + className
  }, React__default.createElement(PlaceHolderContext.Provider, {
    value: {
      isLoaded: isVideoLoaded
    }
  }, placeholder), React__default.createElement("video", {
    className: videoStyles.video,
    ref: forwardedRef || videoRef,
    muted: isBackgroundVideo ? true : muted,
    loop: isBackgroundVideo ? true : loop,
    playsInline: isBackgroundVideo ? false : playsInline,
    controls: isBackgroundVideo ? false : controls,
    onLoadedData: onVideoLoad,
    disableRemotePlayback: isBackgroundVideo ? true : disableRemotePlayback
  }, sources.map(function (source) {
    return isVideoSource(source) ? React__default.createElement("source", {
      key: source.type,
      src: source.src,
      type: source.type
    }) : source;
  })));
});

/**
 *  Calls the provided 'onLoad' parameter if the image is loaded.
 *  Necessary in the rare event that the image source is loaded by the browser before javascript is initialized, meaning that the onLoad in the <img /> element won't fire
 */

function useImageLoad(_ref) {
  var onLoad = _ref.onLoad;
  var imgRef = React.useRef(null);
  React.useEffect(function () {
    var img = imgRef.current;

    if (img && img.complete) {
      onLoad();
    }
  }, []);
  return {
    imgRef: imgRef
  };
}

var cache = /*#__PURE__*/new Set();
var Image = function Image(_ref) {
  var alt = _ref.alt,
      sources = _ref.sources,
      placeholder = _ref.placeholder,
      src = _ref.src,
      onLoad = _ref.onLoad,
      aspectWidth = _ref.aspectWidth,
      aspectHeight = _ref.aspectHeight,
      layout = _ref.layout,
      ariaHidden = _ref.ariaHidden;

  var _useImageLoad = useImageLoad({
    onLoad: onImageLoad
  }),
      imgRef = _useImageLoad.imgRef;

  var _useState = React.useState(false),
      isLoaded = _useState[0],
      setIsLoaded = _useState[1];

  function onImageLoad() {
    // add the src in the cache after a timeout to allow for the placeholder to transition out
    setTimeout(function () {
      cache.add(src);
    }, 1000);
    setIsLoaded(true);

    if (onLoad) {
      onLoad();
    }
  }

  var isCached = cache.has(src);
  var containerClassNameLayout = layout === 'fill' && styles.containerFill || layout === 'responsive' && styles.containerResponsive || '';
  var containerClassName = styles.containerBase + " " + containerClassNameLayout;
  var containerInlineStyles = layout === 'responsive' && {
    paddingBottom: aspectHeight / aspectWidth * 100 + "%"
  } || {};
  return React__default.createElement("div", {
    style: containerInlineStyles,
    className: containerClassName
  }, React__default.createElement(PlaceHolderContext.Provider, {
    value: {
      isLoaded: isLoaded
    }
  }, !isCached && placeholder), React__default.createElement("picture", null, sources.map(function (source, i) {
    return React__default.createElement("source", {
      key: i,
      type: source.type,
      srcSet: source.srcSet,
      sizes: source.sizes
    });
  }), React__default.createElement("img", {
    style: {
      objectFit: 'cover',
      objectPosition: 'center',
      position: 'absolute',
      top: 0,
      left: 0,
      opacity: 1,
      width: '100%',
      height: '100%'
    },
    // src will only be the one used when srcSet is not supported
    src: src,
    alt: alt,
    onLoad: onImageLoad,
    ref: imgRef,
    "aria-hidden": ariaHidden
  })));
};

// https://stream.mux.com/QhB33iydisgSEarLVrPFxm9ssRfyom7duGHZOfjfZIc
var MuxPlayer = /*#__PURE__*/React__default.forwardRef(function (_ref, ref) {
  var playbackId = _ref.playbackId,
      layout = _ref.layout,
      aspectWidth = _ref.aspectWidth,
      aspectHeight = _ref.aspectHeight,
      isBackgroundVideo = _ref.isBackgroundVideo,
      placeholder = _ref.placeholder,
      controls = _ref.controls,
      muted = _ref.muted,
      onLoad = _ref.onLoad,
      loop = _ref.loop,
      autoPlay = _ref.autoPlay,
      playsInline = _ref.playsInline,
      fallbackGifOptions = _ref.fallbackGifOptions,
      preventLoading = _ref.preventLoading,
      className = _ref.className,
      style = _ref.style,
      disableRemotePlayback = _ref.disableRemotePlayback;

  var _useState = React.useState(false),
      useGif = _useState[0],
      setUseGif = _useState[1];

  var videoRef = React.useRef(null);

  var _useState2 = React.useState(false),
      sourceIsLoaded = _useState2[0],
      setSourceIsLoaded = _useState2[1]; // Validate gifOptions


  if (fallbackGifOptions) {
    if (fallbackGifOptions.width > 640) {
      throw new Error("Provided fallbackGifOptions.width was " + fallbackGifOptions.width + " for playbackId: " + playbackId + ". Max width is 640px (hard limit by the mux api.)");
    }

    if (fallbackGifOptions.height && fallbackGifOptions.height > 640) {
      throw new Error("Provided fallbackGifOptions.height was " + fallbackGifOptions.height + " for playbackId: " + playbackId + ". Max height is 640px (hard limit by the mux api.)");
    }

    if (fallbackGifOptions.fps > 30) {
      throw new Error("Provided fallbackGifOptions.fps was " + fallbackGifOptions.fps + " for playbackId: " + playbackId + ". Max fps is 30 (hard limit by the mux api.)");
    }
  } // Allow the client to get the ref, while using it in this components as well.


  React.useEffect(function () {
    if (ref) {
      if (typeof ref === 'function') {
        ref(videoRef.current);
      } else {
        ref.current = videoRef.current;
      }
    }
  }, []);

  function attemptPlay() {
    var _videoRef$current;

    (_videoRef$current = videoRef.current) == null ? void 0 : _videoRef$current.play()["catch"](function (err) {
      console.log('error attempting to play: ', err);

      if (fallbackGifOptions && (autoPlay || isBackgroundVideo)) {
        console.log('Using Gif as fallback');
        setUseGif(true);
      }
    });
  } // @ts-ignore not all codepaths return a value error


  React.useEffect(function () {
    var _videoRef$current2;

    if (preventLoading) return;
    var src = "https://stream.mux.com/" + playbackId + ".m3u8";

    if ((_videoRef$current2 = videoRef.current) == null ? void 0 : _videoRef$current2.canPlayType('application/vnd.apple.mpegurl')) {
      // This will run in safari, where HLS is supported natively
      videoRef.current.src = src;
      setSourceIsLoaded(true);
    } else if (Hls.isSupported()) {
      var hls = new Hls({
        enableWorker: false
      });

      if (videoRef.current) {
        hls.attachMedia(videoRef.current);
        hls.on(Hls.Events.MEDIA_ATTACHED, function () {
          hls.loadSource(src);
        });
      }

      setSourceIsLoaded(true);
      return function () {
        hls.destroy();
      };
    } else {
      // Hls is not supported
      console.log("Browser doesn't support Hls.js, Using Gif as fallback");
      setUseGif(true);
    }
  }, [preventLoading]);
  React.useEffect(function () {
    if (sourceIsLoaded) {
      if (autoPlay || typeof autoPlay === 'undefined' && isBackgroundVideo) {
        attemptPlay();
      }
    }
  }, [sourceIsLoaded, autoPlay, isBackgroundVideo]);

  if (useGif && fallbackGifOptions) {
    var gifParams = [];
    gifParams.push("width=" + fallbackGifOptions.width);

    if (fallbackGifOptions.height) {
      gifParams.push("height=" + fallbackGifOptions.height);
    }

    gifParams.push("fps=" + fallbackGifOptions.fps);
    return (// @ts-ignore
      React__default.createElement(Image, {
        layout: layout,
        aspectWidth: aspectWidth,
        aspectHeight: aspectHeight,
        onLoad: onLoad,
        style: style,
        className: className,
        alt: "",
        sources: [],
        src: "https://image.mux.com/" + playbackId + "/animated.gif?" + gifParams.join('&'),
        placeholder: placeholder
      })
    );
  }

  return (// @ts-ignore sadly have to ignore this as the layout type errors
    React__default.createElement(Video, {
      className: className,
      style: style,
      onLoad: onLoad,
      loop: loop,
      playsInline: playsInline,
      placeholder: placeholder,
      controls: controls,
      muted: muted,
      ref: videoRef,
      layout: layout,
      sources: [],
      autoPlay: false,
      aspectWidth: aspectHeight,
      aspectHeight: aspectWidth,
      isBackgroundVideo: isBackgroundVideo,
      disableRemotePlayback: disableRemotePlayback
    })
  );
});

var css_248z$2 = ".vimeo-module_vimeo__2KlYz {\n  position: absolute;\n  width: 100%;\n  height: 100%;\n  border: none;\n  z-index: 2;\n}\n";
var vimeoStyles = {"vimeo":"vimeo-module_vimeo__2KlYz"};
styleInject(css_248z$2);

/**
 * Vimeo themselves start with an LQIP that then fades into the video.
 * This means that you probably want to use lqip placeholder as well, as using higher resolution image as placeholder,
 * would result a flicker to lqip again
 */

var Vimeo = function Vimeo(_ref) {
  var style = _ref.style,
      className = _ref.className,
      layout = _ref.layout,
      aspectWidth = _ref.aspectWidth,
      aspectHeight = _ref.aspectHeight,
      videoId = _ref.videoId,
      placeholder = _ref.placeholder,
      onLoad = _ref.onLoad,
      isBackgroundVideo = _ref.isBackgroundVideo,
      muted = _ref.muted,
      autoPlay = _ref.autoPlay,
      loop = _ref.loop,
      controls = _ref.controls,
      preventLoading = _ref.preventLoading;

  function onIframeLoad() {
    if (onLoad) {
      onLoad();
    }
  }

  var containerInlineStyles = layout === 'responsive' && {
    paddingBottom: aspectHeight / aspectWidth * 100 + "%"
  } || {};
  var parameters = isBackgroundVideo ? "background=1" : "autoplay=" + +!!autoPlay + "&loop=" + +!!loop + "&muted=" + +!!muted + "&controls=" + +!!controls;
  return React__default.createElement("div", {
    style: _extends({}, containerInlineStyles, style),
    className: styles.containerBase + " " + className
  }, React__default.createElement(PlaceHolderContext.Provider, {
    value: {
      isLoaded: false
    }
  }, placeholder), !preventLoading && React__default.createElement("iframe", {
    className: vimeoStyles.vimeo,
    onLoad: onIframeLoad,
    width: "100%",
    height: "100%",
    frameBorder: "0",
    allow: "autoplay; fullscreen; picture-in-picture",
    src: "https://player.vimeo.com/video/" + videoId + "?title=0&" + parameters
  }));
};

var coverWrapperContainerStyles = {
  position: 'absolute',
  top: 0,
  left: 0,
  overflow: 'hidden',
  width: '100%',
  height: '100%'
};
var coverWrapperStyles = {
  position: 'relative',
  top: 0,
  left: 0,
  zIndex: 1,
  width: '100%',
  height: '100%'
};
var coverStyles = {
  position: 'relative',
  width: '100%',
  height: '100%'
};
var CoverPlaceholder = function CoverPlaceholder(_ref) {
  var fadeOutOptions = _ref.fadeOutOptions,
      coverColor = _ref.coverColor;

  var _useContext = React.useContext(PlaceHolderContext),
      isLoaded = _useContext.isLoaded;

  var transitionOutStyles = fadeOutOptions && {
    transition: "transform " + fadeOutOptions.fadeOutDurationMs + "ms",
    transform: "translate3D(0, " + (isLoaded ? '-101%' : '0%') + ", 0)"
  };
  return React__default.createElement("div", {
    style: coverWrapperContainerStyles
  }, React__default.createElement("div", {
    style: coverWrapperStyles
  }, React__default.createElement("div", {
    style: _extends({}, coverStyles, transitionOutStyles, {
      background: coverColor
    })
  })));
};

var imageStyles = {
  position: 'absolute',
  zIndex: 1,
  top: 0,
  left: 0,
  width: '100%',
  height: '100%'
};
var LqipPlaceholder = function LqipPlaceholder(_ref) {
  var style = _ref.style,
      className = _ref.className,
      base64 = _ref.base64,
      fadeOutOptions = _ref.fadeOutOptions;

  var _useContext = React.useContext(PlaceHolderContext),
      isLoaded = _useContext.isLoaded;

  var _useState = React.useState(false),
      isTransitionEnded = _useState[0],
      setIsTransitionEnded = _useState[1];

  var fadeOutStyles = fadeOutOptions && {
    transition: "opacity " + fadeOutOptions.fadeOutDurationMs + "ms"
  }; // remove the image from dom when isLoaded (or when transition is ended)

  var isHidden = fadeOutStyles ? isTransitionEnded && isLoaded : isLoaded;
  return isHidden ? null : React__default.createElement("img", {
    style: _extends({}, imageStyles, fadeOutStyles, {
      opacity: isLoaded ? 0 : 1
    }, style),
    className: className,
    "aria-hidden": true,
    src: base64,
    onTransitionEnd: function onTransitionEnd() {
      setIsTransitionEnded(true);
    }
  });
};

var wrapperStyles = {
  position: 'absolute',
  top: 0,
  left: 0,
  width: '100%',
  height: '100%'
};
/**
 *
 * This placeholder starts with a LQIP, then resolves the full resolution image which is the the placeholder
 */

var ImagePlaceholder = function ImagePlaceholder(_ref) {
  var base64 = _ref.base64,
      fadeOutOptions = _ref.fadeOutOptions,
      lqipFadeOutOptions = _ref.lqipFadeOutOptions,
      sources = _ref.sources,
      src = _ref.src;

  var _useContext = React.useContext(PlaceHolderContext),
      isLoaded = _useContext.isLoaded;

  var _useState = React.useState(false),
      isTransitionEnded = _useState[0],
      setIsTransitionEnded = _useState[1];

  var fadeOutStyles = fadeOutOptions && {
    transition: "opacity " + fadeOutOptions.fadeOutDurationMs + "ms"
  };
  var isHidden = fadeOutStyles ? isTransitionEnded && isLoaded : isLoaded;
  return React__default.createElement("div", {
    style: _extends({}, wrapperStyles, {
      opacity: fadeOutStyles && isLoaded ? 0 : 1,
      zIndex: isHidden ? -1 : 1
    }, fadeOutStyles),
    onTransitionEnd: function onTransitionEnd() {
      setIsTransitionEnded(true);
    }
  }, React__default.createElement(Image, {
    placeholder: React__default.createElement(LqipPlaceholder, {
      base64: base64,
      fadeOutOptions: lqipFadeOutOptions
    }),
    layout: "fill",
    sources: sources,
    src: src,
    alt: "" // empty to not index placeholder
    ,
    "aria-hidden": true
  }));
};

exports.CoverPlaceholder = CoverPlaceholder;
exports.Image = Image;
exports.ImagePlaceholder = ImagePlaceholder;
exports.LqipPlaceholder = LqipPlaceholder;
exports.MuxPlayer = MuxPlayer;
exports.Video = Video;
exports.Vimeo = Vimeo;
exports.isVideoSource = isVideoSource;
//# sourceMappingURL=responsive-image-react.cjs.development.js.map
