import { ReactElement, CSSProperties } from 'react';
export declare type DistributiveOmit<T, K extends keyof T> = T extends unknown ? Omit<T, K> : never;
declare const VALID_LAYOUT_VALUES: readonly ["fill", "fixed", "responsive"];
declare type LayoutValue = typeof VALID_LAYOUT_VALUES[number];
export declare type LayoutFillProps = {
    layout: 'fill';
    aspectWidth?: never;
    aspectHeight?: never;
};
export declare type LayoutOtherProps = {
    layout: 'fixed' | 'responsive';
    aspectWidth: number;
    aspectHeight: number;
};
export declare type MediaBaseProps = {
    layout: LayoutValue;
    placeholder?: ReactElement;
    className?: string;
    style?: CSSProperties;
} & (LayoutFillProps | LayoutOtherProps);
export declare type BackgroundVideoProps = {
    isBackgroundVideo: true;
    muted?: never;
    autoPlay?: boolean;
    loop?: never;
    controls?: never;
    /**
     * If true, remote playback like chromecast is disabled
     */
    disableRemotePlayback?: never;
};
export declare type VideoControlProps = {
    isBackgroundVideo?: never;
    muted: boolean;
    autoPlay: boolean;
    loop: boolean;
    controls: boolean;
    /**
     * If true, remote playback like chromecast is disabled
     */
    disableRemotePlayback: boolean;
};
export declare type VideoBaseProps = MediaBaseProps & {
    onLoad?(): void;
} & (BackgroundVideoProps | VideoControlProps);
export declare type Source = {
    srcSet: string;
    type: ('image/webp' | 'image/png' | 'image/jpeg') | (string & {});
    sizes?: string;
    media?: string;
};
export declare type FadeOutOptions = {
    fadeOutDurationMs: number;
};
export {};
